;*********************************************************************************************
;   BIG_GEN_III_RS232.ASM
;   
;    
;   RECEPTOR GENERICO DE RF PARA CONTROLE REMOTOS (CHAVEIRINHOS) COM CI HT6P20B/HCS200...301
;   OBS: VERSO MISTA, QUE 'APRENDE' A FAMLIA HCS ( NO USA 'HOPPING CODE', ACEITANDO DE 
;   QUALQUER FABRICANTE) E TAMBM O CI HT6P20B (CDIGO FIXO).
;   MAX: 255 CONTROLE REMOTOS (MEMRIA 24C08)
;   
;   VERSO NO PERMITE REGRAVAR SOBRE POSIO J GRAVADA. NECESSITA PRIMEIRO APAGAR PARA 
;   DEPOIS GRAVAR.
;
;   PARA DECODIFICAR UTILIZA UM  PIC 16F628A DE 18 PINOS.
;   ESTA VERSO PERMITE A GRAVAO E APAGAMENTO INDIVIDUAL DE CONTROLES, MEDIANTE A VISUALIZAO
;   EM DISPLAY LCD, DO  NMERO DO CONTROLE QUE SE DESEJA GRAVAR/APAGAR.
;   OBJETIVO: AJUDAR HOBYSTAS A TER UMA BASE PARA SEUS PRPRIOS PROJETOS COM CONTROLES REMOTOS.

;   USO: OS PINOS  6 E 7  DO PIC16F628A SO AS SAIDAS QUE SERO USADAS PARA ACIONAR OUTROS DISPOSI
;   TIVOS COMO RELES,LED,TRIAC,ETC, OU SEJA, A SUA APLICAO. 
;   OBS.CADA BOTO DO CONTROLE ACIONA UMA SADA .
;   UTILIZA O PINO 1 COMO SADA SERIAL A 9600 BAUDS PARA OUTROS DISPOSITIVOS DE CONTROLE
;   COMO APLICATIVO EM PC, ARDUINO, ETC.CADA ACIONAMENTO SER ENVIADO O SERIAL NUMBER DO TX.
;   PROJETO DIDTICO EXPERIMENTAL, SUJEITO A BUG'S EM USO. TESTADO SOMENTE EM PROTOBOARD.

;   AUTOR: CLAUDIO LRIOS     INICIO: 26-12-2012  TERMINO:30-12-2012
;
;   OBS. ADAPTAO DO PROJETO BIG_GEN COM AT89C2051 PARA PIC16F628A DO MESMO AUTOR
;*************************************************************************************************
;   HISTRICO:

;   MODIFICAO EM 04/03/2014 PARA PODER TAMBM REALIZAR GRAVAO INDIVIDUALIZADAS DE CONTROLES.
;
;   MODIFICAO EM 08/03/2014 PARA PODER TAMBM ENVIAR PELA SERIAL O SERIAL NUMBER DO TX ACIONADO
;   ALTERADO TAMBM A LIGAO DOS INTERRUPTORES DACTILARES NA PLACA PARA LIBERAR PINOS 15 /16
;   PARA USAR CRISTAL (NECESSRIO PARA ESTABILIDADE DA COMUNICAO SERIAL).
;
;   MODIFICADO EM  13/04/2014 PARA ENVIAR APS SERIAL NUMBER:1 PARA SAIDA 1, 2 PARA SAIDA 2 E 
;   3 PARA AMBAS SAIDAS ACIONADAS.  
;   TAMBM IMPEDE GRAVAO DE POSIO SEM ESTAR COM 0XFF (EXIGE APAGAMENTO DA POSIO ANTES 
;   DE REALIZAR UMA GRAVAO).
;
;   MATERIAL DIDTICO APENAS.
;   BLOG 'LARIOS.TECNOLOGIA.WS'
;   (LIBERADO PARA USO NO COMERCIAL)
;*********************************************************************************************
;   INSTRUES DE USO:
;
;   GRAVAR CONTROLES:        APERTE UM BOTO DO CONTROLE E MANTENHA APERTADO  AT QUE 
;   APARECER A  MENSAGEM: 'GRAVAR/REMOVER?'. APERTE BOTO 1 PARA 'GRAVAR CONTROLE'.
;   ESCOLHA A POSIO QUE SER GRAVADO O CONTROLE USANDO OS BOTES 1 (RAPIDO) E 2 (LENTO).
;   APERTE BOTO 'LEARN' QUANDO DESEJAR GRAVAR A POSIO ESCOLHIDA.
;   OCORRER A MENSAGEM: ' ACIONE O BOTAO DO TX'. APERTE UM DOS BOTES DO TX PARA GRAVA-LO.
;   POR FACILIDADE, APS GRAVAR UM CONTROLE, APARECER O NMERO DA PRXIMA POSIO. PODER
;   GRAVAR NESTA POSIO POR SIMPLESMENTE APERTAR 'LEARN' E O PRXIMO CONTROLE. O PROCESSO SE
;   REPETIR PARA MAIS CONTROLES. CASO DESEJE OUTRAS POSIES, USE O BOTO 1 E 2 PARA AJUSTAR.
;   OBS. SE POSIO ESTIVER GRAVADA, APARECER MENSAGEM: 'REMOVER TX ANTES'. APAGUE PRIMEIRO
;   ANTES DE TENTAR REGRAVAR OUTRO CONTROLE NESTA POSIO.
;   ESTA VERSO 'ZERA' AS INFORMAES DOS BOTES APERTADOS, DE MANEIRA QUE, PROGRAMANDO APENAS
;   QUALQUER UM DOS BOTES, OS OUTROS   SERO AUTOMATICAMENTE ACEITOS.
;   O OBJETIVO DISTO  POUPAR MEMRIA PARA PODERMOS  GRAVAR MAIS CONTROLES NA EEPROM.
;   ATENO: AO GRAVAR, APERTE 'LEARN' E IMEDIATAMENTE O BOTO DO CONTROLE DESEJADO. 
;   NESTA SITUAO, QUALQUER CONTROLE NO CADASTRADO DE TERCEIROS QUE FOR ACIONADO 
;   COINCIDENTEMENTE NESTA OCASIO PODER SER GRAVADO POR ENGANO (SE DEMORAR PARA APERTAR O
;   BOTO DO CONTROLE APS TER APERTADO O BOTO 'LEARN').APS GRAVAR OS CONTROLES DESEJADOS
;   SAIA DO MODO DE PROGRAMAO POR APERTAR O BOTO 'RESET' NO PINO 4.
;   OBS. SE TENTAR GRAVAR CONTROLE J CADASTRADO, IR MOSTRAR A FRASE ' RECEBENDO TX N.'
;   SEGUIDO DE SEU NMERO , SAINDO AUTOMTICAMENTE DO MODO DE  PROGRAMAO.
;
;   APAGAR CONTROLES: NESTA VERSO, PODEMOS OPTAR POR APAGAR TODA A MEMRIA OU APAGAR DE FORMA
;   INDIVIDUAL CADA CONTROLE. APERTE BOTO 'LEARN' POR MAIS DE 10 SEG., APS O QUE APARECER A
;   MENSAGEM: 'GRAVAR/REMOVER?'. APERTE BOTO 2 PARA 'REMOVER CONTROLE'.
;   EM SEGUIDA A MENSAGEM 'APAGAR UNICO TX? DIG: 1=SIM 2=NO'.
;   CASO SEJE UM UNICO CONTROLE A APAGAR, APERTE BOTO '1'. SE APERTAR BOTO '2'(NO) IR PARA 
;   A TELA DE APAGAMENTO DE TODA A MEMRIA.
;   APS APERTAR BOTO '1'(SIM) IR MOSTRAR A MENSAGEM 'ESCOLHA N. TX' OU SEJA , ESCOLHA O NUMERO 
;   DO TRANSMISSOR A APAGAR. LOGO A TELA IR MOSTRA A MENSAGEM 'DIG: L=E 1=^^ 2=^' OU SEJA, DIGITE
;   'LEARN' PARA APROVAR O APAGAMENTO DO CONTROLE ALISTADO NA LINHA 2 DO LCD.
;   DIGITE 1 PARA ALTERAR  DE FORMA RPIDA O VALOR DO CONTROLE A APAGAR .
;   DIGITE 2 ,IGUALMENTE  AO ANTERIOR, SOMENTE DE  FORMA LENTA, PARA  FACILITAR A ESCOLHA. 
;   AO APERTAR 1 OU 2 VEREMOS O VALOR DA LINHA 2 DO LCD  INCREMENTAR DE '1 A 255' .
;   APS ESCOLHERMOS O VALOR DESEJADO, BASTA APERTAR O BOTO 'LEARN' QUE  OCORRER O APAGAMENTO 
;   E  O LCD MOSTRAR A MENSAGEM 'APAGAMENTO OK'. 
;   CASO DESEJE CANCELAR  QUALQUER OPERAO, APERTE 'RESET'.
;   CASO TENHAMOS ESCOLHIDO ANTERIORMENTE BOTO 2 (NO) LEVAR A MENSAGEM: 
;   'APAGAR TODOS TX? DIG: 1=SIM 2=NO'
;   AO DIGITAR BOTO 1 (SIM), UM A MENSAGEM DE CONFIRMAO APARECER. DIGITE BOTO 1 (SIM) PARA 
;   FINALIZAR O APAGAMENTO GERAL. EM SEGUIDA , APARECER A MENSAGEM 'AGUARDE....' E LOGO EM SEGUIDA
;   A MENSAGEM 'APAGAMENTO OK'. SE APS A MENSAGEM 'APAGAR TODOS TX?' TECLA BOTO 2(NO), APARECER
;   A MENSAGEM 'AP. CANCELADO' OU SEJA, A OPERAO DE APAGAMENTO FOI CANCELADA, E RETORNA AO INICIO
;   DO PROGRAMA.


;
;   QUANTIDADE DE CONTROLES MAXIMA: 255 CONTROLES DIFERENTES. 
;   USE LCD 2 X 16 PARA INDICAO VISUAL (TECH 1602B)
;   UTILIZE EEPROM 24C08 
;   USE CRISTAL DE 4MHZ NOS PINOS 15 E 16
;   OBS. A RECEPO COM CI HCS EST LIMITADA A 400 US DE PULSO BSICO. OUTROS VALORES NO IRO
;   FUNCIONAR CORRETAMENTE.
;********************************************************************************************* 
; LIGAES NOS PINOS DO PIC 16F628A:
;	PINO 1=  SADA RS232
;	PINO 2=  ENTRADA INTERRUPTOR 'RPIDO' A MASSA
;	PINO 3=  ENTRADA DO SINAL A DECODIFICAR VIA RESISTOR DE 470 OHMS 
;	PINO 4=  RESET
;	PINO 5=  GND
;	PINO 6=  SAIDA 'S1'  LED2
;	PINO 7=  SAIDA 'S0'  LED1
;	PINO 8=  SAIDA E
;	PINO 9=  SAIDA RS
;	PINO 10= SAIDA DB4
;	PINO 11= SAIDA DB5
;	PINO 12= SAIDA DB6
;	PINO 13= SAIDA DB7
;	PINO 14= VCC (+5V)
;	PINO 15= ENTRADA INTERRUPTOR 'LENTO' A MASSA
;	PINO 16= AO VCC VIA RESISTOR DE 10K E AO BOTO DE 'LEARN' A MASSA
;	PINO 17= SDA DA 24C04 (DADO) 
;	PINO 18= SCL DA 24C04 (CLOCK) 

; USE CRISTAL DE 4MHZ NO PINO 15 E 16 PARA ASSEGURAR ESTABILIDADE NA SERIAL
;*****************************************************************************************

	LIST P=16f628A , R=DEC
	INCLUDE "P16F628A.INC"
	ERRORLEVEL      -302   
;=====================================================================================================
;PALAVRA DE CONFIGURAO
	__CONFIG		_CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC  & _BODEN_OFF & _LVP_OFF & _MCLRE_ON
;=====================================================================================================
;BANCOS
#DEFINE		BANK0	BCF	STATUS,RP0 	;SETA BANK0 DE MEMORIA
#DEFINE		BANK1	BSF	STATUS,RP0	;SETA BANK1
;====================================================================================================
;EQUATES
VLINHA1      EQU  80H
VLINHA2      EQU  0C0H
T_APRESENTAO EQU  .5   ;TEMPO DE APRESENTAO DA FRASE NO LCD
;------------------------------------------------------------------------------

;MACROS
LIMPA  MACRO		;LIMPA TELA DO LCD
    CALL   LcdClear
   	MOVLW 	.7     ;AJUSTAR 5 MSEG
    CALL   DELAY
    ENDM
LINHA1 MACRO        ;TROCA PARA LINHA 1 DO LCD
    CALL   LINE1
   	MOVLW 	.7     ;AJUSTAR 5 MSEG
    CALL   DELAY
    ENDM
LINHA2 MACRO        ;TROCA PARA LINHA 2 DO LCD
    CALL   LINE2
   	MOVLW 	.7     ;AJUSTAR 5 MSEG
    CALL   DELAY
    ENDM
   

;=======================================================================================================
;DEFINIES DE RAM

      CBLOCK  0X20
       TEMP,FLAGS,BOT,TMP,B0,B1,ADDRESS,ADDRESS1,AUX,DYTA,QB,Z3,Z2,Z1,LC,HC,CONT,RES3A,RES2A,RES1A,RES0A
       RES3,RES2,RES1,RES0,BR0,BR1,BR2,C0,C1,R0,R1,R2,R3,R4,R5,R6,R7,TR,PAG,QTX,QTX1,B0X,B1X,BUFFER,CNT,CNT1
      ENDC

;DEFINIES DA PORTAS 
;===============================================================================
#DEFINE SDA         PORTA,0	        ; LINHA DE DADOS DA 24C02 (5)  PINO 17
#DEFINE SCL         PORTA,1    	    ; LINHA DE CLOCK DA 24C02 (6)
#DEFINE T_232       PORTA,2    	    ; SAIDA RS232 PINO 1
#DEFINE RFIN        PORTA,4         ;PINO  3  IN RF
#DEFINE LED1        PORTB,1	        ;PINO  7 - SAIDA DO LED2
#DEFINE LED2        PORTB,0	        ;PINO  6 - SAIDA DO LED1
#DEFINE LCD_DB7     PORTB,7         ;PINO 13 - DISPLAYS
#DEFINE LCD_DB6     PORTB,6	        ;PINO 12 - DISPLAY 
#DEFINE LCD_DB5     PORTB,5         ;PINO 11 - DISPLAYS
#DEFINE LCD_DB4     PORTB,4	        ;PINO 10 - DISPLAY 
#DEFINE LCD_RS      PORTB,3         ;PINO 9 - DISPLAY 
#DEFINE LCD_E       PORTB,2         ;PINO 8 - DISPLAY 
;#DEFINE LRN         PORTA,7         ;PINO  16   IN LEARN BOTTON  
;#DEFINE DOWN        PORTA,3         ;PINO 2 - BOTO 'RPIDO' N.1
;#DEFINE UP          PORTA,6         ;PINO 15 - BOTO 'LENTO'  N.2
;#DEFINE SW_N1       PORTA,3         ;PINO 2 - BOTO 'RPIDO' N.1
;#DEFINE SW_N2       PORTA,6         ;PINO 15 - BOTO 'LENTO'  N.2
#DEFINE SW          PORTA,3         ;RETORNO DAS CHAVES
;==================================================================================
;FLAGS
#DEFINE FLAGH	FLAGS,0         ;FLAG DE SITUAO
#DEFINE FLAG1	FLAGS,1         ;FLAG DE NOVA LEITURA
#DEFINE FLAGGR  FLAGS,2         ;FLAG DE 'LEARN' APRENDER
#DEFINE FLAGPA  FLAGS,3         ;FLAG DE PRE-AMBULO
#DEFINE FLAGX   FLAGS,4         ;FLAG DE RECEPO OK HT6P
#DEFINE FLAGY   FLAGS,5         ;FLAG RECEPO OK HCS
#DEFINE FPROG   FLAGS,6         ;FLAG AGUARDA RECEPO PARA FINS DE GRAVAO
;VARIAVIS DE TEMPO  E CARGA DE CONTADORES
;==============================================================================
TMAX     EQU  .50        ;TEMPO MAXIMO DO SINAL LOW
QBYTE    EQU  .28        ;QUANTIDADE DE BYTES A SER RECEBIDO (22 ADRESS+ 2 DADO + 4 ANTICODE)
TGR      EQU  .200       ;TEMPO DE BOTO APERTADO PARA APAGAR GRAVAAO
TAMG     EQU  0X27        ;TEMPO MAXIMO EM TELA DE APAGAMENTO
PONTM    EQU  0X03FE      ;ENDEREO DO PONTEIRO DA MEMRIA EEPROM EXT.
LEDACESO EQU  .2         ;TEMPO QUE LED'S DA SAIDA FICAM ACESOS APS UM TOQUE


;============================================================================================
;                 ENDEREO INICIAL DE RESET DO MICROCONTROLADOR
;============================================================================================
	ORG 0X00
    GOTO   START
;============================================================================================
;                 ROTINA DE ENVIO DE FRASE PARA O LCD (PAGINA 0 E 1)
;=============================================================================================
ENV_LCD
     MOVWF  AUX
     MOVFW  PAG
     MOVWF  PCLATH
     MOVFW  AUX
RT1
    CALL PEGA_M
    ADDLW  .0
    BTFSC  STATUS,Z
    RETURN
    CALL    ED
    INCF   AUX,F
    MOVFW   AUX
    GOTO  RT1

PEGA_M
    MOVWF    PCL
FRASE1:
	dt "BIG_GEN_PIC628_E",0
FRASE2:
	dt "LARIOS.TECNOL.WS",0
FRASE3:
	dt "REMOVER CONTROLE",0
FRASE4:
	dt "LIM. MAX MEMORIA",0
FRASE5:
	dt "APAGAR TODOS TX?",0
FRASE6:
	dt "DIG: 1=SIM 2=NAO",0
FRASE7:
	dt "APAG. CANCELADO!",0
FRASE8:
	dt "APAGAMENTO OK!!!",0
FRASE9:
	dt "CONFIRME: TODOS!",0
FRASE10:
	dt "OK! TX APRENDIDO",0
FRASE11:
	dt "AGUARDE ........",0
FRASE12:
	dt "APAGAR UNICO TX?",0
FRASE13:
	dt "ESCOLHA N. DO TX",0
FRASE14:
	dt "1=^R 2=^ L=E R=C",0
;=============================================================================
;               PAGINA 1
;=============================================================================
    ORG  0X100  ;COLOCA DENTRO DE UMA UNICA PAGINA
FRASE15:
	dt "RECEBENDO TX N.:",0
FRASE16:
	dt "TX DESCONHECIDO!",0
FRASE17:
	dt "AGUARDANDO TX..!",0
FRASE18:
	dt "GRAVAR/REMOVER ?",0
FRASE19:
	dt "1=GRAVA 2=REMOVE",0
FRASE20:
	dt "GRAVAR CONTROLE ",0
FRASE21:
	dt "GRAVAR TX N.    ",0
FRASE22:
	dt "ACIONE BOTAO TX ",0
FRASE23:
	dt "REMOVER TX N.   ",0
FRASE24:
    dt "REMOVER TX ANTES",0
;=============================================================================
;               ROTINA DE INICIALIZAO DE PORTAS E REGISTRADORES
;=============================================================================
RESETA:	
START:
    MOVLW  .7
    MOVWF  CMCON        ;DESLIGA COMPARADORES ANALGICOS
;DEFINE ENTRADAS E SAIDAS
    BANK1
    MOVLW  B'11111000'   ;SAIDA SOMENTE RA0,RA1,RA2
    MOVWF  TRISA
    MOVLW  .0
    MOVWF  TRISB       ;TUDO SAIDA
    BANK0
	CLRF PORTA           ;PORTA ; RESET PORTA
	CLRF PORTB 		     ;PORTB ; RESET PORTB
	CLRF FLAGS 		     ;FLAGS; RESET FLAGS
    CLRF PAG             ;ZERA ESCOLHA DE PAGINA DO PCLATH
	CLRF ADDRESS1        ;PAGINA ZERO DA EEPROM
    CALL LCDINIT         ;INICIALIZAO DO LCD
	CALL FRASEINIT	     ;FRASE INICIAL
	MOVLW .5             ;TEMPO DE APRESENTAO
    CALL DELAYW
    LIMPA	    	 ;LIMPAR TELA
    MOVLW .1
    MOVWF PAG
	CALL FRASE_AGUARDANDO_TX ;MENSAGEM 'AGUARDANDO TX..!'
    MOVLW  TGR
    MOVWF  Z2     ;CARGA DO TEMPO DO BOTO 'LEARN' APERTADO PARA ENTRAR NA 'FUNO DE APAGAMENTO'
    CLRF   Z1
    
;===============================================================================================
;          ROTINA PRINCIPAL
;===============================================================================================

INICIO:
    CLRF   RES3     ;APAGA REGISTRADORES DE RECEPO DE CDIGO
	CLRF   RES2 
	CLRF   RES1 
	CLRF   RES0   

    MOVLW  QBYTE
	MOVWF  QB     ;PREPARA PARA A RECEPO COM NUMERO DE BITS A RECEBER
     
L0:
     BCF   FLAGH   ;LIMPA FLAG E REGISTRADORES DE RECEPO
     CLRF   HC  ;APAGA REGISTRADORES DE UNS  E ZEROS
     CLRF   LC 
L1:
      BSF   LCD_DB5   ;SETA 'B'
      BCF    LCD_DB4        ;SETA 'C'
      BCF    LCD_DB6        ;SETA 'A'
      BTFSS SW        ; DOWN
      GOTO  PRT7
      BTFSC SW        ;DOWN
      GOTO  $-1
PRT7:
     BSF    LCD_DB6   ;SETA 'A'
     BCF    LCD_DB5        ;SETA 'B'
     BCF    LCD_DB4        ;SETA 'C'
     BTFSS   SW       ;LRN
     GOTO    L1HZ		;TESTA BOTO 'LEARN' APERTADO
     GOTO    MODO_PROG  ;APERTADO, COMEA A CONTAR TEMPO MAX. DE APAGAMENTO
L1HZ:
     MOVLW    TGR
	 MOVWF   Z2      ;CARGA DO TEMPO DO BOTO 'LEARN' 
     CLRF    Z1      ;

L1H:
     GOTO    SS5

;==========================================================================================================
;            MODO DE PROGRAMAO :   GRAVAR/ REMOVER CONTROLES REMOTOS
;==========================================================================================================


MODO_PROG:
	
       ;APAGAR TODOS OS CONTROLES DA MEMRIA
      DECFSZ Z1,F
      GOTO   L1H
      DECFSZ Z2,F
      GOTO   L1H      ;QUANDO A CONTAGEM DESTE REGISTRADORES (Z1,Z2) CHEGAR AO FIM OCORRE 'MODO DE APAGAMENTO'
	  LIMPA     ;LIMPA
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEGRREV   ;FRASE :'GRAVAR/REMOVER'
 	  LINHA2     ;PEM NA SEGUNDA LINHA
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEOPGRREV   ;FRASE :'1=GRAVA 2=REMOVE'
      MOVLW  T_APRESENTAO
	  CALL  DELAYW
LOOP_56
      BSF    LCD_DB5        ;SETA 'B'
      BCF    LCD_DB4        ;RESETA 'C'
      BCF    LCD_DB6        ;RESETA 'A'
      BTFSC  SW             ;SW_N1 - TESTA BOTO N1 =GRAVA
      GOTO   GRAVA_TX
      BSF    LCD_DB4        ;SETA 'C'
      BCF    LCD_DB5        ;RESETA 'B'
      BCF    LCD_DB6        ;RESETA 'A'
      BTFSC  SW             ;SW_N2-TESTA BOTO N2
      GOTO   APAGAMENTO_TX
      GOTO   LOOP_56
;===============================================================================================
;           ROTINA PARA GRAVAO DE  TX PARA UMA POSIO DA MEMRIA ESCOLHIDA PELO USURIO
;===============================================================================================

GRAVA_TX:
     CLRF ADDRESS1     ;CONDIO INICIAL
     CLRF ADDRESS    
     CALL C_MAX
     LIMPA
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEGRAVARTX  ;FRASE :'GRAVAR CONTROLE'
      MOVLW  T_APRESENTAO
	  CALL  DELAYW
      LIMPA
      CLRF  PAG
      CALL  FRASEAP_ETX  ;FRASE :'ESCOLHER N. TX'
      MOVLW  T_APRESENTAO
	  CALL  DELAYW
      LIMPA     ;LIMPA DISPLAY
      CLRF  PAG
      CALL  FRASEUP_DOWN   ;FRASE :"1=^R 2=^ L=E R=C"
      LINHA2
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEGRAVARTXNUM  ;FRASE :'GRAVAR TX N.'
      CALL   SALVA_ADDRESS_X  ; SALVA B0X=ADDRESS1 E B1X=ADDRESS
      GOTO   LOOP_57

;=================================================================================
;   INCREMENTA CONTADOR COM NUMERO DO TX A GRAVAR
;=================================================================================
VOLTA_APOS_RX:
      LINHA2
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEGRAVARTXNUM  ;FRASE :'GRAVAR TX N.'
      CALL   RECUPERA_ADDRESS_X     ; RETORNA ADDRESS1=B0X E ADDRESS=B1X
      CALL   INC_ADDRESS_4X ;INCREMENTA 4 VEZES PARA GRAVAR PRXIMO TX (FACILIDADE)
      GOTO   H34

LOOP_57
      CALL   RECUPERA_ADDRESS_X     ; RETORNA ADDRESS1=B0X E ADDRESS=B1X
H34
      BSF    LCD_DB5        ;SETA 'B'
      BCF    LCD_DB6        ;RESETA 'A'
      BCF    LCD_DB4        ;RESETA 'C'
      BTFSS  SW             ;SW_N1-TESTA BOTO N1 =INCREMENTO RAPIDO
      GOTO   J66
      CALL   INC_ADDRESS_4X ;INCREMENTA 4 VEZES
J66
      BSF    LCD_DB4        ;SETA 'C'
      BCF    LCD_DB5        ;RESETA 'B'
      BCF    LCD_DB6        ;RESETA 'A'
      BTFSS  SW             ;SW_N2 -TESTA BOTO N2
      GOTO   PIT1
      CALL   INC_ADDRESS_4X ;INCREMENTA 4 VEZES
      MOVLW  .250
      CALL   DELAY         ;DELAY PARA MODO LENTO

PIT1
      MOVFW  ADDRESS1
      XORLW  0X03
      BTFSS  STATUS,Z      ;LIMITA A 3FC
      GOTO   SUH1
      MOVFW  ADDRESS
      SUBLW  0XF8
      BTFSC  STATUS,C
      GOTO   SUH1


      CLRF   ADDRESS1
      CLRF   ADDRESS

SUH1

      MOVLW  0XCC
      CALL   EC
      CALL   SALVA_ADDRESS_X  ; SALVA B0X=ADDRESS1 E B1X=ADDRESS
      CALL   SHOW_TX		  ;MOSTRA NO LCD
      MOVLW  .60
      CALL   DELAY           ;DELAY PARA MODO LENTO
      BSF    LCD_DB6        ;SETA 'A'
      BCF    LCD_DB4        ;RESETA 'C'
      BCF    LCD_DB5        ;RESETA 'B'
      BTFSS   SW             ;LRN-TESTA SE DEVE GRAVAR ESTE NUMERO PARA O TX
      GOTO   LOOP_57         ;NO
;==============================================================================
;       TESTA SE ENDEREO J FOI REMOVIDO CONTROLE ANTES DE GRAVAR NOVO
;==============================================================================
      CALL   RECUPERA_ADDRESS_X     ; RETORNA ADDRESS1=B0X E ADDRESS=B1X
      CALL   END_LIVRE         ;PROCURA SE O ENDEREO NO TEM CONTROLE J GRAVADO
      BTFSC  STATUS,Z
      GOTO   LEARN_TX
      LIMPA
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEREMOVANTX  ;FRASE :"REMOVER TX ANTES"
      MOVLW  T_APRESENTAO
	  CALL  DELAYW
      GOTO   START
;==============================================================================
;       PREPARANDO PARA GRAVAR O TX NO NMERO ESCOLHIDO
;==============================================================================
LEARN_TX
      LIMPA
      CLRF  PAG
      INCF  PAG,F
      CALL  FRASEACIONEX  ;FRASE :'ACIONE BOTAO TX.'
      BSF  FPROG     ;SETA PARA CAPTURAR PRXIMA RECEPO
      GOTO  INICIO

;==============================================================================================
;    APAGAR CONTROLE REMOTO
;==============================================================================================
APAGAMENTO_TX:      
	  LIMPA     ;LIMPA
      CLRF  PAG
      CALL  FRASEAPM   ;FRASE :'REMOVER CONTROLE'
      MOVLW  T_APRESENTAO
	  CALL  DELAYW
      GOTO  APAGA_ESCOLHA

CANCEL:
	 LIMPA  ;LIMPA DISPLAY E MUDA PARA LINHA 1 DO LCD
     CLRF  PAG
     CALL FRASECANC
     MOVLW  T_APRESENTAO     
	 CALL DELAYW
	 GOTO START

APAGA_ESCOLHA:

	 LIMPA
	 CLRF  PAG
	 CALL FRASEAP_UNICOTX   ;MENSAGEM DE 'APAGAR UNICO TX?'
	 LINHA2
     CLRF  PAG
     CALL FRASE_DIG   ;FRASE :'DIG:1=SIM 2=NAO'
     CALL C_MAX


VUT5B:
    DECFSZ Z1,F
    GOTO   VUT7Y
    DECFSZ Z2,F
    GOTO   VUT7Y
    DECFSZ Z3,F
    GOTO   VUT7Y
    GOTO   START
VUT7Y:
;TESTA BOTES
     BSF    LCD_DB4        ;SETA 'C'
     BCF    LCD_DB5        ;RESETA 'B'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSC  SW             ;LENTO 2
	 GOTO APAGAR_TODOS
     BSF    LCD_DB5        ;SETA 'B'
     BCF    LCD_DB4        ;RESETA 'C'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSS SW              ;RAPIDO 1
     GOTO  VUT5B
     
APAGAR_UM:     
     LIMPA
     CLRF  PAG
     CALL FRASEAP_ETX  ;MENSAGEM DE 'ESCOLHA N. DO TX'
     MOVLW  T_APRESENTAO
     CALL  DELAYW
     LIMPA
	 CLRF  PAG
     CALL FRASEUP_DOWN ;MENSAGEM 'DIG:L=E 1=^^ 2=^'
     LINHA2

  	 CLRF ADDRESS1     ;CONDIO INICIAL
     MOVLW  .1
     MOVWF ADDRESS 
     CALL C_MAX
     GOTO VFP5A         ;MOSTRA SITUAO INICIAL


VUT5C:
	DECFSZ Z1,F
    GOTO   VUT7Z
    DECFSZ Z2,F
    GOTO   VUT7Z
    DECFSZ Z3,F
    GOTO   VUT7Z
    GOTO   START
	
VUT7Z:
;TESTA BOTES
     BSF    LCD_DB6        ;SETA 'A'
     BCF    LCD_DB5        ;RESETA 'B'
     BCF    LCD_DB4        ;RESETA 'C'
     BTFSC  SW             ;LRN
     GOTO   APAGAR_NUM
     BSF    LCD_DB4        ;SETA 'C'
     BCF    LCD_DB6        ;RESETA 'A'
     BCF    LCD_DB5        ;RESETA 'B'
     BTFSC  SW             ;UP
	 GOTO   INC_NTX
     BSF    LCD_DB5        ;SETA 'B'
     BCF    LCD_DB4        ;RESETA 'C'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSS  SW             ;DOWN
     GOTO   VUT5C
    
INC_NTX:
     MOVLW  TAMG
     MOVWF  Z3         ;EVITA SAIR POR TEMPO ENQUANTO ACERTANDO N. DO TX
	 CALL   INC_ADDRESS  


     MOVLW  .1              ;LIMITA CONTAGEM ENTRE 1 A 255 CONTROLES        
     XORWF  ADDRESS1,W
     BTFSS  STATUS,Z
     GOTO   VFP5A
  	 CLRF   ADDRESS1   ;ZERA CONTAGEM
     MOVLW  .1
     MOVWF  ADDRESS 

VFP5A:
     MOVFW  ADDRESS1  ;CARREGA REGISTRADOR DE CONVERSO
     MOVWF  C1
	 MOVFW  ADDRESS 
     MOVWF  C0
	 LINHA2    ;MUDA PARA 2LINHA
     CLRF  PAG
     INCF  PAG,F
     CALL FRASEREMOVER  ;MENSAGEM DE 'REMOVER TX N.'
     MOVLW  0XCD
     CALL   EC          ;APONTA ONDE SER MOSTRADO O NMERO NO LCD
     CALL   SHOW_ADDR ;CONVERTE E APRESENTA NO LCD O VALOR DE ADDRESS1/ADDRESS

      MOVLW  0X02 
      BSF    LCD_DB5        ;SETA 'B'
      BCF    LCD_DB6        ;RESETA 'A'
      BCF    LCD_DB4        ;RESETA 'C'
      BTFSS  SW             ; =1 AJUSTE LENTO
      GOTO   SS4R
      MOVLW  .60
      CALL   DELAY  ;DELAY MENOR
 	  GOTO  VUT5C
SS4R:
      CALL DELAYW
      GOTO  VUT5C
;================================================================================================
;                REMOVER UM NICO  TX
;================================================================================================
APAGAR_NUM:
      CALL  ADDRESS_X_4   ;MULTIPLICA ADDRESS1/ADDRESS POR 4
      CALL DEC_ADDRESS  ;DECREMENTA
      MOVLW  0XFF
      MOVWF DYTA 
      CALL EEWRITE1  ;APAGA ENDEREO APONTADO POR ADDRESS1,ADDRESS
	  CALL DEC_ADDRESS
      CALL EEWRITE1
      CALL DEC_ADDRESS
      CALL EEWRITE1
	  CALL DEC_ADDRESS
      CALL EEWRITE1
	  GOTO SAPAG     ;SAI COM MENSAGEM DE 'APAGAMENTO OK'
;================================================================================================
;                REMOVER TODOS OS   TX'S
;================================================================================================

APAGAR_TODOS:
     LIMPA
	 CLRF  PAG
     CALL FRASEAP_TODOS  ;MENSAGEM DE 'APAGAR TODOS TX'
     CALL FRASE_DIG
     MOVLW  T_APRESENTAO
     CALL  DELAYW
     CALL C_MAX
     GOTO  VUT5

CANCELX:
	GOTO CANCEL

VUT5:
	DECFSZ Z1,F
    GOTO   VUT7W
    DECFSZ Z2,F
    GOTO   VUT7W
    DECFSZ Z3,F
    GOTO   VUT7W
    GOTO   START
VUT7W:
;TESTA BOTES
     BSF    LCD_DB4        ;SETA 'C'
     BCF    LCD_DB5        ;RESETA 'B'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSC  SW             ;UP
     GOTO  CANCELX
     BSF    LCD_DB5        ;SETA 'B'
     BCF    LCD_DB4        ;RESETA 'C'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSS  SW             ; DOWN
     GOTO  VUT5
     LINHA1
     CLRF  PAG
     CALL FRASECONFTODOS

     MOVLW   0X15 
     CALL DELAYW
     CALL C_MAX

VUT6:
	DECFSZ Z1,F
    GOTO   VUT7Q
    DECFSZ Z2,F
    GOTO   VUT7Q
    DECFSZ Z3,F
    GOTO   VUT7Q
    GOTO   START
C_MAX:
     MOVLW  TAMG
     MOVWF   Z3    
     CLRF   Z2        ;CARGA DO TEMPO MAXIMO ANTES DE VOLTAR AO INICIO
     CLRF   Z1        ;LIMPA REGISTRADORES
     RETURN
VUT7Q:
;TESTA BOTES
     BSF    LCD_DB4        ;SETA 'C'
     BCF    LCD_DB5        ;RESETA 'B'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSC  SW             ;UP
     GOTO   CANCELX
     BSF    LCD_DB5        ;SETA 'B'
     BCF    LCD_DB4        ;RESETA 'C'
     BCF    LCD_DB6        ;RESETA 'A'
     BTFSS  SW             ;DOWN
     GOTO   VUT6
     LIMPA       ;LIMPA TELA
     CLRF  PAG
     CALL   FRASEAGUARDE ; MENSAGEM 'AGUARDE......'
     CALL   ER_ALL_EEPROM ;APAGAR  TODOS TX DA MEMRIA
SAPAG:
     LIMPA  ;LIMPA TELA
     CLRF  PAG
     CALL   FRASEAPOK ;FRASE 'APAGAMENTO OK!!!'
     MOVLW  T_APRESENTAO/2
     CALL   DELAYW
     BSF    LCD_DB6        ;SETA 'A'
     BCF    LCD_DB5        ;RESETA 'B'
     BCF    LCD_DB4        ;RESETA 'C'
     BTFSC  SW             ;LRN-AGUARDA SOLTAR BOTO 'LEARN'
     GOTO   $-1
     GOTO   START


RECEIVE:

;INICIA ROTINA DE RECEPO DE SINAL DO HT6P20B/HCS200...301
;==========================================================
SS5:
     BTFSS  FLAGH	;TESTA FLAG DE HUM RECEBIDO ;FLAG=0 VAI PARA L2 
     GOTO   L2
     BTFSC  FLAGPA
     GOTO   W47
     BTFSS  RFIN
     GOTO   M0		 ;SIN ? TESTA SINAL DE ENTRADA DO RECEPTOR DE RF SIN=0 VAI PARA 'MO'
     GOTO   L2  
W47: 
     BTFSS  FLAGPA
     GOTO   W48
     BTFSC  RFIN
     GOTO   M0  
W48: 
L2:
    BTFSS  RFIN
    GOTO   LA1		;SIN=0  VAI INCREMENTAR LC EM 'LA1'
    BTFSC  FLAGPA
    GOTO   W45		;SIN=1  VAI INCREMENTAR HC E SETAR FLAG
    BSF    FLAGH    ;SIN=1
W45: 
	INCFSZ HC,F
	GOTO   LA2
	DECF   HC,F
	GOTO   LA2	   ;VAI PARA 'LA2' CONTAR TEMPO DE 50 MICRO SEGUNDOS
LA1:
    BTFSS  FLAGPA
    GOTO   W46
	BSF    FLAGH     ;SIN=1  
W46: 

     INCFSZ  LC,F     ;INCREMENTA REGISTRADOR DE LOW SIGNAL NA ENTRADA RF
     GOTO    LA2
     DECF    LC,F
LA2:
;	 MOVLW   .5  ;.12
;     MOVWF   R0   ; 24D = 50 MICROSEG DELAY (ACERTA TEMPO ENTRE LEITURAS DA ENTRADA DE RF)
 ;    DECFSZ  R0,F
 ;    GOTO    $-1
     GOTO    L1
M0:
    ;OK  LC>TMAX C=0 (VAI PARA O INICIO)

     MOVFW  LC			;C=0 (-)  ENTO =  LC>TMAX
     SUBLW  TMAX
     BTFSC  STATUS,C    ;TESTA SE NO PASSOU DO LIMITE MAXIMO DE TEMPO EM LOW NA ENTRADA DE RF
     GOTO   NK
     
     MOVFW  QB
     XORLW  .17
     BTFSS  STATUS,Z    ;SE A=17, ENTO  UM PREAMBULO DO HCS.
     GOTO   F23         ;#17
	 BSF    FLAGPA      ;=17
     
     MOVLW  .63       ;SE SETADO, TRANSMISSO HCS
     MOVWF  QB 
     BTFSS  RFIN
     GOTO   $-1
     GOTO   L0
F23:
	 BCF    FLAGPA
     MOVLW  .28
     MOVWF  QB 
	 GOTO   INICIO

;===============================================================================================
NK:
	
     ;OK  C=1 SE LC>HC

;G
	
SEG58:
    MOVFW  HC			;OBTEM O VALOR DE 'CARRY'(HUM OU ZERO)
    SUBWF  LC,W
    
    RRF    RES3,F       ;DESLOCA  O BIT NOS REGISTRADORES DE RESULTADO
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F
	GOTO   SEG44

;XLO:
     ; GOTO  L0      ;LE PROXIMO BIT
;-------------------------------------
SEG44:

;H
    DECFSZ  QB,F    ;DECREMENTA O CONTADOR DE BITS A SER RECEBIDO
    GOTO    L0
    BTFSC   FLAGPA
    GOTO    SEG66
    MOVLW   .4
    MOVWF   QB         ;DESPREZA OS 4 BITS DE 'ANTICODE' 1010
ACERTA:

    BCF    STATUS,C
    RRF    RES3,F
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F        ;RESULTADO FICA SOMENTE EM RES2 A RES0,DESPREZA RES3
	DECFSZ QB,F
    GOTO   ACERTA
    
    BTFSC  FLAG1
    GOTO   PULA1

    MOVFW  RES2        ;SALVA RESULTADOS DA PRIMEIRA RECEPO
    MOVWF  RES2A
    MOVFW  RES1
    MOVWF  RES1A
    MOVFW  RES0
    MOVWF  RES0A

    BSF    FLAG1       ;SETA FLAG DE PRIMEIRA RECEPO RECEBIDA

    MOVLW  .28
    MOVWF  QB 
    GOTO   INICIO
PULA1:

	BCF FLAG1          ;SEGUNDA RECEPO, COMPARA COM A PRIMEIRA
	MOVFW  RES2
    XORWF  RES2A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
    MOVFW  RES1
    XORWF  RES1A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
	MOVFW  RES0
    XORWF  RES0A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC	  ;ERRO DE RECEPO
	BSF    FLAGX		    ;OK - BOA RECEPO HT6P20B
    MOVLW  .28
	MOVWF  QB 
	GOTO   ROT_HT6P

SEG66: 
    BSF    FLAGY           ;OK - BOAS RECEPO HCS
    BCF    FLAG1
    MOVLW  .28
    MOVWF  QB 
    BCF    FLAGPA
    GOTO   ROT_HCS

RESETAC:
	CLRF   RES3A     ; APAGA RESULTADOS DE COMPARAO
    CLRF   RES2A
    CLRF   RES1A
	CLRF   RES0A
SAI_ROT:
    BCF    FLAGX
	BCF    FLAGH
    MOVLW  .28
	MOVWF  QB 
    GOTO   INICIO
	
ROT_HCS:
    MOVFW  RES3   ;SALVA NIBLE DOS BOTES
    ANDLW  0XF0
	MOVWF  BOT 
    MOVFW  RES3   ;SALVA NIBLE DOS BOTES
    ANDLW  0X0F
    MOVWF  RES3   ;APAGA BOTES
    GOTO   ACAO
     
ROT_HT6P:
      CLRF   RES3   ;APAGA (SEM USO)
      BCF    STATUS,C ;SALVA NIBLE DOS BOTES
      RRF    RES2,W
      ANDLW  B'01100000'  ;ACERTA POSIO CORRETA DE SAIDA
      MOVWF  BOT      ;SOMENTE 'LED1' E 'LED2'
      MOVFW  RES2
      ANDLW  0X0F
      MOVWF  RES2    ;APAGA BOTES
VAC:
;======================================================================

;INICIA O TRATAMENTO DOS DADOS RECEBIDOS

;======================================================================


ACAO:
    LIMPA
    MOVLW  .1
    MOVWF  PAG
	CALL  FRASE_RECEBETX
    MOVLW  0X03
    MOVWF  B0              ;INICIO DA PROCURA POR TX GRAVADOS
    MOVLW  0XFB
    MOVWF  B1              
MADDRESS:
    
F27: 
    CALL  RECUPERA_ADDRESS ; ADDRESS1=B0 E ADDRESS=B1
    CALL   EEREAD1
    XORWF  RES3,W		;COMPARA COM RES3
    BTFSS  STATUS,Z
    GOTO   PROXIMO
    CALL  DEC_ADDRESS   ;DECREMENTA ADDRESS/ADDRESS1
    CALL   EEREAD1
    XORWF  RES2,W		;COMPARA COM RES2
    BTFSS  STATUS,Z
    GOTO   PROXIMO
    CALL  DEC_ADDRESS   ;DECREMENTA ADDRESS/ADDRESS1
    CALL   EEREAD1
    XORWF  RES1,W		;COMPARA COM RES1
    BTFSS  STATUS,Z
    GOTO   PROXIMO
    CALL  DEC_ADDRESS   ;DECREMENTA ADDRESS/ADDRESS1
    CALL   EEREAD1
    XORWF  RES0,W		;COMPARA COM RES0
    BTFSS  STATUS,Z
    GOTO   PROXIMO
    GOTO   ACIONAR	    ;ENCONTRADO CONTROLE NA MEMRIA
;====================================================================
; DECREMENTA ENDEREO DA EEPROM
DEC_ADDRESS:
	DECF  ADDRESS,F
    MOVFW ADDRESS
    XORLW 0XFF
    BTFSS  STATUS,Z
    GOTO  SEG26
    DECF  ADDRESS1,F
	
SEG26:
	RETURN
;====================================================================
PROXIMO:
    CALL  RECUPERA_ADDRESS ; ADDRESS1=B0 E ADDRESS=B1
    MOVLW  .4
    SUBWF  ADDRESS,F   ;SUBTRAI 4 POSIES
    BTFSC  STATUS,C
    GOTO   SFE          ;
    MOVLW  .1
    SUBWF  ADDRESS1,F
   ; BTFSC  STATUS,Z
   ; GOTO   APRENDER
    BTFSC  STATUS,C
    GOTO   SFE
    GOTO   APRENDER     ;CONTROLE NO ENCONTRADO NA MEMRIA,VAI PARA 'APRENDER'
SFE:
    MOVFW  ADDRESS
    MOVWF  B1
    MOVFW  ADDRESS1
    MOVWF  B0
    GOTO   MADDRESS					;VAI PARA O PROXIMO ENDEREO DE MEMRIA .PROCURAR....
    
     
APRENDER:
    BTFSC  FPROG         ;TESTA SE DEVE GRAVAR ESTE TX
    GOTO   GRAV_C
    LINHA2
    MOVLW  .1
    MOVWF  PAG
    CALL  FRASE_DESCONHECIDO
    MOVLW    .1 
    CALL  DELAYW
    GOTO   INICIO      ;NO EST.  
;==================================================================================================
;                                 GRAVANDO NA EEPROM O TX RECEBIDO 
;==================================================================================================

GRAV_C
     CALL   RECUPERA_ADDRESS_X  ; RETORNA ADDRESS1=B0X E ADDRESS=B1X
     CALL W_RES3_0              ;GRAVA RES3 A RES0 NA EEPROM EXTERNA 24C08
 
PUL_GR:
    BCF    FLAGGR
    BSF    LCD_DB6        ;SETA 'A'
    BTFSC  SW             ;LRN - ESPERA SOLTA BOTO 'LEARN'
    GOTO  $-1
    LIMPA     ;LIMPA TELA
    CLRF  PAG
	CALL  FRASETXAPRENDIDO   ;FRASE 'OK! TX APRENDIDO'
    MOVLW  T_APRESENTAO
    CALL  DELAYW            ;TEMPO DE APRESENTAO
    GOTO  VOLTA_APOS_RX     ;VOLTA A ROTINA DE GRAVAO PARA O PROXIMO TX
  
    
ACIONAR:

;==============================================================================================
;     VISUALIZAR  O NUMERO DO CONTROLE ACIONADO
;==============================================================================================
	  MOVLW  0XC7    ;CENTRALIZA O NUMERO DO CONTROLE RECEBIDO NO VISOR, NA 2LINHA
      CALL EC 
      CALL  RECUPERA_ADDRESS ; ADDRESS1=B0 E ADDRESS=B1
      CALL  SHOW_TX   ;MOSTRA VALOR DE ADDRESS1/ADDRESS /4 + 1

;===============================================================================================
;     ACIONA AS SADAS PARA APLICAES (PINOS 6 E 7) CONFORME BOTO ACIONADO NO CONTROLE REMOTO
;===============================================================================================
 
    BTFSS BOT,6  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO E ACIONA LEDS NA SAIDA
    GOTO  PY5
    BSF   LED2
PY5
    BTFSS BOT,5 ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO E ACIONA LEDS NA SAIDA
    GOTO PY4
    BSF   LED1
PY4
    CALL   ENVIA_NSERIAL   ;TRANSMITE NMERO DO SERIAL DO TX PARA SERIAL
    MOVLW  LEDACESO ;TEMPO QUE SE MANTEM ACESOS
	CALL  DELAYW
    BCF    LED1     ;DESLIGA DEPOIS DO TEMPO
    BCF    LED2
    CLRF   BOT
    GOTO   INICIO


;******************************************************************
;
;     ROTINAS DE DELAY E OUTRAS
;
;******************************************************************


;===================================================================
;     MOSTRA NO DISPLAY O VALOR DE ADDRESS1/ADDRESS + 4 /4
;===================================================================

SHOW_TX
   	  CALL   INC_ADDRESS_4X ;   ADDRESS_SOMA_4 A ADDRES1/ADDRESS
      CALL   ADDRESS_DIV_4  ;DIVIDE POR 4
	  MOVFW ADDRESS1
      MOVWF  C1
      MOVFW ADDRESS 
      MOVWF  C0

;===================================================================
;     MOSTRA NO DISPLAY APENAS O VALOR DE ADDRESS1/ADDRESS 
;===================================================================

SHOW_ADDR:
SDT1:
	CALL HEX_DEC

	MOVFW  BR1
    CALL  conv_asc2 
	;CALL ED         ;ULTIMO ZERO
    MOVFW   R1
	CALL ED
      
	MOVFW  BR0
    CALL  conv_asc2 
	CALL ED
   	MOVFW  R1
    CALL ED
    RETURN  
;====================================================================================================
;            ROTINA QUE  DIVIDE POR  4  ADDRESS1/ADDRESS
;====================================================================================================
ADDRESS_DIV_4
      BCF  STATUS,C    ;/2
      RRF  ADDRESS1,F
      RRF  ADDRESS,F
      BCF  STATUS,C   ;/4
      RRF  ADDRESS1,F              
      RRF  ADDRESS,F
      RETURN
;====================================================================================================
;           ROTINA QUE MULTIPLICA POR 4 ADDRESS1/ADDRESS
;====================================================================================================
ADDRESS_X_4
      BCF  STATUS,C
      RLF  ADDRESS,F
      RLF  ADDRESS1,F
      BCF  STATUS,C
      RLF  ADDRESS,F
      RLF  ADDRESS1,F  
      RETURN
 
;=====================================================================================================
;             ROTINA QUE INCREMENTA ADDRESS1/ADDRESS
;=====================================================================================================
INC_ADDRESS:
    INCFSZ  ADDRESS,F
	GOTO    SYE2
	INCF    ADDRESS1,F
SYE2:
   	RETURN
;======================================================================================================
;             ROTINA QUE INCREMENTA 4 VEZES O VALOR DE ADDRES1/ADDRESS ( MESMO QUE SOMAR 4)
;======================================================================================================
INC_ADDRESS_4X
   CALL    INC_ADDRESS
   CALL    INC_ADDRESS
   CALL    INC_ADDRESS
   CALL    INC_ADDRESS
   RETURN
;======================================================================================================
;            ROTINA DE RETORNO DE VALORES (POP) DO PAR B0/B1
;======================================================================================================
RECUPERA_ADDRESS
      MOVFW  B1
      MOVWF ADDRESS   ;RECUPERA VALOR DA POSIO DE MEMRIA A APRESENTAR
      MOVFW  B0
      MOVWF ADDRESS1 
      RETURN
;======================================================================================================
;            ROTINA DE RETORNO DE VALORES (POP) DO PAR B0X/B1X
;======================================================================================================
RECUPERA_ADDRESS_X
      MOVFW  B0X     	 ;RETORNA SALVO ADDRESS1=B0X E ADDRESS=B1X
      MOVWF  ADDRESS1
      MOVFW  B1X 
      MOVWF  ADDRESS   
      RETURN
;======================================================================================================
;            ROTINA DE SALVAMENTO DE VALORES (PUSH) DO PAR B0/B1
;======================================================================================================
SALVA_ADDRESS_X          ;SALVA   B0X=ADDRESS1 E B1X=ADDRESS
      MOVFW  ADDRESS1     ;SALVA
      MOVWF  B0X
      MOVFW  ADDRESS 
      MOVWF  B1X 
      RETURN
;======================================================================================================
;           ROTINA DE ESCRITA DE RES3 A RES0 NA EEPROM EXTERNA  24C08
;======================================================================================================
W_RES3_0:

    MOVFW   RES0
    MOVWF    DYTA       	;CARREGA REGISTRO DE GRAVAO
    CALL   EEWRITE1    	;ROTINA DE ESCRITA NA EEPROM
    CALL   INC_ADDRESS       ;PROXIMA POSIO DE ESCRITA NA EEPROM
    MOVFW  RES1
    MOVWF    DYTA        	;CARREGA REGISTRO DE GRAVAO
    CALL   EEWRITE1
    CALL   INC_ADDRESS       ;PROXIMA POSIO DE ESCRITA NA EEPROM
    MOVFW  RES2
    MOVWF    DYTA      		;CARREGA REGISTRO DE GRAVAO
    CALL   EEWRITE1
    CALL   INC_ADDRESS       ;PROXIMA POSIO DE ESCRITA NA EEPROM
    MOVFW  RES3
    MOVWF   DYTA       		;CARREGA REGISTRO DE GRAVAO
    CALL   EEWRITE1
    RETURN
;======================================================================================================
;           ROTINA DE VERIFICAO DE ENDEREO LIVRE NA 24C08
;======================================================================================================
END_LIVRE:
    CALL   EEREAD1
    XORLW  0XFF
    BTFSS  STATUS,Z
    RETLW  .1         ;GRAVADO AINDA
    CALL   INC_ADDRESS       ;PROXIMA POSIO DE LEITURA NA EEPROM
    CALL   EEREAD1
    XORLW  0XFF
    BTFSS  STATUS,Z
    RETLW  .1         ;GRAVADO AINDA
    CALL   INC_ADDRESS       ;PROXIMA POSIO DE LEITURA NA EEPROM
    CALL   EEREAD1
    XORLW  0XFF
    BTFSS  STATUS,Z
    RETLW  .1         ;GRAVADO AINDA
    CALL   INC_ADDRESS       ;PROXIMA POSIO DE LEITURA NA EEPROM
    CALL   EEREAD1
    XORLW  0XFF
    BTFSS  STATUS,Z
    RETLW  .1         ;GRAVADO AINDA
    RETLW  .0         ;ENDEREO LIVRE
 
;=====================================================================================
;           ROTINA DE DELAY
;=====================================================================================
AGUARDE:	;ROTINA DE ATRASO ENTRE OPERAES DE EEPROM
DELAY_STOP:	
	MOVLW 	.15     ;AJUSTAR 10 MSEG
    CALL   DELAY
	RETURN


;=======================================================================================
;      I2C   ROTINAS PARA EEPROM 24C0X
;=======================================================================================

I2C_READ:            ;reading 8 bits from i2c device
	MOVLW  .8
	MOVWF  R7
GFD:
    BANK1
	BSF    TRISA,0	     ;SDA= ENTRADA
    BANK0
    BSF    SCL
    BCF    STATUS,C
    BTFSC  SDA
    BSF    STATUS,C
    RLF    TEMP,F
    BCF    SCL
    DECFSZ  R7,F
    GOTO   GFD
    MOVFW  TEMP      ;RETORNA EM 'W' OS 8 BITS LIDOS
    BANK1
    BCF    TRISA,0   ;SDA = SAIDA
    BANK0
    RETURN

I2C_WRITE:           ;writing 8 bits in to i2c device
	MOVWF  TEMP      ;SALVA O DADO A ESCREVER
	MOVLW  .8
	MOVWF  R7
WRITING:
	
    RLF    TEMP,F
    BCF    SDA
    BTFSC  STATUS,C
    BSF    SDA
    CALL CLOCK
    DECFSZ  R7,F
    GOTO   WRITING
    RETURN

I2C_START:           ;start of i2c routine

	BSF SCL
    BSF SDA 
    NOP
    BCF SDA
    NOP
    BCF SCL
    RETURN

I2C_STOP:            ;end of i2c routine
	BCF SDA
	BSF SCL
	NOP
	BSF SDA 
	NOP
	BCF SCL
	RETURN

CLOCK:               ;synchronizing clock 
	BSF SCL
	NOP
    NOP
    NOP
	BCF SCL
	RETURN



ACK:                ;acknowledge from transmitter or receiver
 	
 	BSF SCL
    BANK1
    BSF  TRISA,0   ;ENTRADA
    BANK0
    BTFSC  SDA
    GOTO  $-1
 	BCF SCL
    BANK1
    BCF  TRISA,0  ;SAIDA
    BANK0
 	RETURN

NO_ACK:             ;no acknowledge from transmitter or receiver
 	
  	BCF SCL
 	BANK1
    BSF  TRISA,0   ;ENTRADA
    BANK0
    BTFSS  SDA
    GOTO  $-1
 	
 	BSF SCL
	BANK1
    BCF  TRISA,0   ;saida
    BANK0
 	RETURN
;***************************************************************** 
;  ROTINA DE ESCRITA NA EEPROM
;******************************************************************
EEWRITE1:	     ;COLOQUE ENDEREO EM 'ADDRESS','ADDRESS1'  E DADO EM 'DYTA'
EEPROM_WRITE:        ;write in to eeprom
 	CALL I2C_START
 	CALL EEPROM_WRITE_ADDR
 	CALL ACK

;MOV  A,#0         ;USE SOMENTE PARA ADDRESS DUPLO
;LCALL I2C_WRITE
;LCALL ACK

    MOVFW   ADDRESS
 	CALL I2C_WRITE
 	CALL ACK

    MOVFW   DYTA
 	CALL I2C_WRITE
 	CALL ACK
 	CALL I2C_STOP
 	CALL DELAY_STOP
    RETURN
;***********************************************************************
;       ROTINA DE LEITURA NA EEPROM
;***********************************************************************
EEREAD1:    ;COLOQUE ENDEREO EM 'ADDRESS' E RECEBA O DADO EM 'DYTA'E 'A'
EEPROM_READ:         ;LENDO A EEPROM
 	CALL I2C_START
 	CALL EEPROM_WRITE_ADDR
 	CALL ACK

; MOVLW  .0      ;SOMENTE PARA MEMORIAS COM  ENDEREO DUPLO
; CALL I2C_WRITE
; CALL ACK


    MOVFW  ADDRESS		
 	CALL I2C_WRITE
 	CALL ACK
 	CALL I2C_START
 	CALL EEPROM_READ_ADDR
 	CALL ACK
 	CALL I2C_READ
 	CALL NO_ACK
 	CALL I2C_STOP
	MOVWF  DYTA
	RETURN
;--------------------------------------------

;EEPROM_READ_ADDR:     ;A2,A1,A0 ZERAR
 	;MOVLW   B'10100001'
	;CALL I2C_WRITE
	;RETURN

;EEPROM_WRITE_ADDR:    ;A2,A1,A0 ZERAR
	;MOVLW B'10100000'
 	;CALL I2C_WRITE
	;RETURN


EEPROM_READ_ADDR:     ;ENDEREA PAGINA APONTADA POR ADDRESS1 E POSIO EM ADDRESS
	BSF  STATUS,C
    RLF  ADDRESS1,W   ;DESLOCA ENDEREO DE ADDRESS PARA ESQ E COLOCA 1 (LEITURA)
    ADDLW  0XA0			;SOMA OS 10100000B
    CALL I2C_WRITE
	RETURN


EEPROM_WRITE_ADDR:    ;ENDEREA PAGINA APONTADA POR ADDRESS1 E POSIO EM ADDRESS
    BCF  STATUS,C
    RLF  ADDRESS1,W
    ADDLW  0XA0			;SOMA OS 10100000B
    CALL I2C_WRITE
	RETURN



;*************************************************************************************************
;   APAGAMENTO GERAL DE TODAS AS PAGINAS DA EEPROM     
;==================================================================================================
ER_ALL_EEPROM:
	MOVLW   .4
    MOVWF R1    ; 4 PAGINAS DE 256 BYTES (24C08)
	CLRF ADDRESS1   ;PAGINA ZERO
VAP1:
	CALL EEERASE  ;APAGA TODA 256 (1 PAG) NA EEPROM
    INCF ADDRESS1,F   ;INCREMENTA A PAGINA
    DECFSZ  R1,F
    GOTO   VAP1
    RETURN
;*************************************************************************************************
;  APAGAMENTO DE TODA  UMA PAGINA DA EEPROM
;-------------------------------------------------------------
EEERASE:	        ;APAGA TODAS AS POSIES DE MEMRIA SELECIONADA EM A0 (1=PAGINA HIGH/0=PAG LOW)
	MOVLW  .32
    MOVWF   R6		;32 PAGINAS DE 8 BYTES
    MOVLW  .8		; 8 BYTES POR PAGINA 
    MOVWF   R5
	CLRF   ADDRESS 
EET1:
 	CALL I2C_START
	CALL EEPROM_WRITE_ADDR
	CALL ACK
    MOVFW  ADDRESS
	CALL I2C_WRITE
	CALL ACK

EET2: 

    MOVLW 	0XFF 
	CALL 	I2C_WRITE
	CALL	 ACK
    DECFSZ  R5,F
    GOTO    EET2
	CALL 	I2C_STOP
    CALL   DELAY_STOP ; TEMPO DE GRAVAO
    MOVLW  .8
    ADDWF   ADDRESS,F
    DECFSZ  R6,F
    GOTO    EET1
    CALL   DELAY_STOP
	RETURN

;===================================================================================
;		ROTINA PARA CONVERSO  DE 16 BITS PARA  5 BCD (3BYTES)
;
;	EX: C0=FF
;		C1=FF		
;	 SER  APS CONVERSO :
;		RES2=06 , RES1=55  ,RES0=35  (OBS.  VALOR MXIMO 65535)
;==================================================================================
;   RESERVAR ESTES REGISTRADORES NA   MEMRIA ( SRAM)
;	LC   data 20H	;LOOPCOUNTER
;	BR0 data 21H	;RESULTADOS DA CONVERSO
;	BR1 data 22H
;	BR2 data 23H
;	C1   data 24H	;VALOR DE ENTRADA ALTO
;	C0   data 25H	;BAIXO
HEX_DEC:	
    MOVLW .16
	MOVWF  LC     ;CARREGA 16
	CLRF  BR0 	;ZERA RESULTADOS
	CLRF  BR1 
	CLRF  BR2 

VOLTA:	
    BCF  STATUS,C
	RLF  C0,F    ;DESLOCA PARA ESQUERDA C0,C1,BR0,1,2
	RLF  C1,F 
	RLF  BR0,F  
	RLF  BR1,F 
	RLF  BR2,F
	DECFSZ LC,F  ;VERIFICA SE CHEGOU AO FIM DA CONVERSO
    GOTO SEG9
	RETURN			;FI DA CONVERSO
SEG9:
	MOVLW .3 
	ADDWF BR2,W	;SOMA  3 EM RES2
	ANDLW .8 	; 2ELEV 3=8
    XORLW .8
    BTFSS  STATUS,Z
    GOTO  NSOMA3		;=0 ,ENTO NO SOMA 3 (SE ZERO RETORNA VALOR ORIGINAL)
	MOVLW .3
    ADDWF BR2,F 		; =1 ENTAO SOMA 3

NSOMA3:
	MOVLW 0X30
	ADDWF BR2,W
	ANDLW  0X80 
    XORLW  0X80
    BTFSS  STATUS,Z
    GOTO   NSOMA3A		;=0 ,ENTO NO SOMA 30h
	MOVLW 0X30 	; =1 ENTAO SOMA 30h
	ADDWF  BR2,F

NSOMA3A:
	MOVLW .3 
	ADDWF BR1,W	;SOMA  3 EM RES2
	ANDLW .8 	; 2ELEV 3=8
    XORLW .8
    BTFSS  STATUS,Z
    GOTO  NSOMA3B		;=0 ,ENTO NO SOMA 3 (SE ZERO RETORNA VALOR ORIGINAL)
	MOVLW .3
    ADDWF BR1,F 		; =1 ENTAO SOMA 3
NSOMA3B:
	MOVLW 0X30
	ADDWF BR1,W
	ANDLW  0X80 
    XORLW  0X80
    BTFSS  STATUS,Z
    GOTO   NSOMA3C		;=0 ,ENTO NO SOMA 30h
	MOVLW 0X30 	; =1 ENTAO SOMA 30h
	ADDWF  BR1,F
NSOMA3C:
	MOVLW .3 
	ADDWF BR0,W	;SOMA  3 EM RES2
	ANDLW .8 	; 2ELEV 3=8
    XORLW .8
    BTFSS  STATUS,Z
    GOTO  NSOMA3D		;=0 ,ENTO NO SOMA 3 (SE ZERO RETORNA VALOR ORIGINAL)
	MOVLW .3
    ADDWF BR0,F 		; =1 ENTAO SOMA 3
NSOMA3D:
	MOVLW 0X30
	ADDWF BR0,W
	ANDLW  0X80 
    XORLW  0X80
    BTFSS  STATUS,Z
    GOTO   NSOMA3E		;=0 ,ENTO NO SOMA 30h
	MOVLW 0X30 	; =1 ENTAO SOMA 30h
	ADDWF  BR0,F
NSOMA3E:
	GOTO VOLTA

;========================================================================
;OK
CONV_ASC2:
conv_asc2:  ; converte 2 nibles hex em 2 nibles asc2 lsb=r1 msb=a  

	MOVWF R0 
	ANDLW 0X0F
	ADDLW  0XF6 
	BTFSC  STATUS,C 
	GOTO LETRAS
	ADDLW  0X3A 
	GOTO SAIQ

LETRAS:
	ADDLW	0X41 

SAIQ:
	MOVWF R1 
	SWAPF R0,F
    MOVFW R0
    ANDLW  0X0F 
    ADDLW  0XF6 
    BTFSC  STATUS,C  
    GOTO   LETRAS1
    ADDLW  0X3A 
    GOTO  SAIQ1

LETRAS1:
   ADDLW	0X41 
SAIQ1:
   RETURN
	

;=================================================================================
;           ROTINAS DE ENVIO DE FRASES PARA O LCD
;=================================================================================
FRASEINIT
	
	MOVLW  FRASE1
	CALL  ENV_LCD
    CALL  LINE2
	MOVLW  FRASE2
	CALL  ENV_LCD
    RETURN
FRASEAPM:
 	MOVLW  FRASE3
	CALL  ENV_LCD ;'REMOVER CONTROLE'
	RETURN
FRASELIMITE_MAX:
	MOVLW  FRASE4
	CALL  ENV_LCD ;''LIM.MAX MEMORIA'
	RETURN
FRASEAP_TODOS:
	MOVLW  FRASE5
	CALL  ENV_LCD;'APAGAR TODOS TX'
    RETURN
FRASE_DIG:
	LINHA2    ;MUDA PARA LINHA 2
	MOVLW  FRASE6
	CALL  ENV_LCD;'DIG: 1=SIM 2=NA0'
	RETURN
FRASECANC:
	MOVLW  FRASE7
	CALL  ENV_LCD ;''APAG. CANCELADO!'
	RETURN
FRASEAPOK:
	MOVLW  FRASE8
	CALL  ENV_LCD ;''APAGAMENTO OK!!!'
	RETURN
FRASECONFTODOS:
	MOVLW  FRASE9
	CALL  ENV_LCD ;'CONFIRME:TODOS!'
    RETURN
FRASETXAPRENDIDO:
	MOVLW  FRASE10
	CALL  ENV_LCD ;'OK!TX APRENDIDO!'
	RETURN
FRASEAGUARDE:
	MOVLW  FRASE11
	CALL  ENV_LCD ;'AGUARDE........!'
	RETURN
FRASEAP_UNICOTX:
	MOVLW  FRASE12
	CALL  ENV_LCD ;'APAGAR UNICO TX'
    RETURN
FRASEAP_ETX:
	MOVLW  FRASE13
	CALL  ENV_LCD;'ESCOLHA N. TX'
	RETURN
FRASEUP_DOWN:
	MOVLW  FRASE14
	CALL  ENV_LCD ;'1=^R 2=^ L=E R=C'
	RETURN
FRASE_RECEBETX:
	MOVLW LOW(FRASE15)
	CALL  ENV_LCD ;'RECEBENDO TX N.:'
	RETURN
FRASE_DESCONHECIDO:
	MOVLW  LOW(FRASE16)
	CALL  ENV_LCD ;'TX DESCONHECIDO!'
	RETURN
FRASE_AGUARDANDO_TX:
	MOVLW  LOW(FRASE17)
	CALL  ENV_LCD ;'AGUARDANDO TX..!'
	RETURN
FRASEGRREV:
	MOVLW  LOW(FRASE18)
	CALL  ENV_LCD ;'GRAVAR/REMOVER.!'
	RETURN
FRASEOPGRREV:
    MOVLW  LOW(FRASE19)
	CALL  ENV_LCD ;'1=GRAVA 2=REMOVE!'
	RETURN
FRASEGRAVARTX:
    MOVLW  LOW(FRASE20)
	CALL  ENV_LCD ;'GRAVAR CONTROLE'
	RETURN
FRASEGRAVARTXNUM:
    MOVLW  LOW(FRASE21)
	CALL  ENV_LCD ;'GRAVAR TX N.'
	RETURN
FRASEACIONEX:
    MOVLW  LOW(FRASE22)
	CALL  ENV_LCD ;'GRAVAR TX N.'
	RETURN
FRASEREMOVER:
    MOVLW  LOW(FRASE23)
	CALL  ENV_LCD ;'REMOVER TX N.'
	RETURN
FRASEREMOVANTX:
    MOVLW  LOW(FRASE24)
	CALL  ENV_LCD ;"REMOVER ANTERIOR"
	RETURN
;=================================================================================
;              ROTINAS DE DELAY GERAIS
;=================================================================================
DELAY2
				MOVLW .20
DELAYW
				MOVWF TEMP
VJ1				call  LcdDelay1
	    		DECFSZ TEMP,F
				GOTO  VJ1
                
DELAY1
LcdDelay1		MOVLW   .255     ;DELAY PARA VISUALIZAAO

DELAY
LcdDelay
				goto $+1
				movwf   LC+1	;duas variveis em uma
LcdDelayLoop					
                decfsz  LC+0,F		;dec. o prim. cont.
                goto    LcdDelayLoop
                decfsz  LC+1,F		;dec. o seg. cont.
                goto    LcdDelayLoop
                return

DEBOUNCE	
WAIT_16MSEC 
				movlw .16	
WAIT_WMSEC 
				movwf LC+1	
WAITSET 
				movlw .250	
				movwf LC	
WAITLOOP 	
				decfsz LC,F	
				goto WAITLOOP		
				decfsz LC+1,F	
				goto WAITSET	
				return	

;=====================================================
WAIT_uS 
				movwf LC
WAIT_uS_A 
				decfsz LC, F
				goto WAIT_uS_A	
				return	
	
;=================================================================================
;Rotinas de controle do LCD
;=================================================================================
LCDINIT
LcdInit			movlw   .30              ;Wait 30 ms
                call    LcdDelay
                
			    
                bcf     LCD_RS    ;Set LCD command mode
                bsf     LCD_DB4	;0011->48
                bsf     LCD_DB5	
				bcf     LCD_DB6
				bcf     LCD_DB7	
                call	LcdPulse_E		;sequncia de reset
                call	LcdPulse_E
                call	LcdPulse_E
				
			    bcf     LCD_DB4
				bcf     LCD_DB6
				bcf     LCD_DB7
                bsf     LCD_DB5
                call	LcdPulse_E

                movlw   28H				;Set 4 bit data bus length
                call    EC
                movlw   06H				;Entry mode set, increment, no shift
                call    EC
	 		;	movlw   0DH				;Display ON, Cursor  ON, Blink ON
	 		;	movlw   0FH				;Display ON, Cursor ALTERADO ON, Blink ON
              ;  movlw   0EH				;Display ON, Cursor ON, Blink OFF
			    movlw   0CH				;Display ON, Cursor OFF, Blink OFF
                call    EC
LcdClear		movlw   01H				;clear display
                call    EC
                movlw   .2               ;Wait 2 ms
                call    LcdDelay
                return


BIN_ASC_ED  					  ;ROTINA DE BINARIO PARA HEX 0-F COM ENVIO PARA LCD
	   			 ANDLW 0X0F                ;LIMITA 0-F
	   			 ADDLW 0XF6				  ;SOMA 0XF6
	   			 BTFSC STATUS,C            ;TESTA CARRY
	   			 ADDLW 0X07                ;C=1 ,ENTO SOMA + 7
	   			 ADDLW 0X3A                ;SOMA 0X3A
           				  ;ENVIA PARA O LCD E RETORNA PARA O PONTO DE CHAMADA


ED
LcdSendData		bsf     LCD_RS
			    GOTO    XENV
LINE1           MOVLW   0X80
                GOTO    EC
LINE2           MOVLW   0XC0
EC
LcdSendCommand	bcf     LCD_RS
XENV            

LcdSendByte		movwf   TR		;Send a byte to LCD by 4 bit data bus
				
			    bcf     LCD_DB4
				bcf     LCD_DB5
				bcf     LCD_DB6
				bcf     LCD_DB7
                btfsc   TR,4
                bsf     LCD_DB4
                btfsc   TR,5
                bsf     LCD_DB5
                btfsc   TR,6
                bsf     LCD_DB6
                btfsc   TR,7
                bsf     LCD_DB7

                call	LcdPulse_E
               	bcf     LCD_DB4
				bcf     LCD_DB5
				bcf     LCD_DB6
				bcf     LCD_DB7
                btfsc   TR,0
                bsf     LCD_DB4
                btfsc   TR,1
                bsf     LCD_DB5
                btfsc   TR,2
                bsf     LCD_DB6
                btfsc   TR,3
                bsf     LCD_DB7

				call	LcdPulse_E
				
                return

;LcdPulse_E	                                           ;CONFORME SEU LCD 
				bsf     LCD_E     ;Enables LCD
               	GOTO    $+1
				GOTO    $+1
				GOTO    $+1
				GOTO    $+1
				GOTO    $+1
                bcf     LCD_E     ;Disabled LCD
			    return

LcdPulse_E		bsf     LCD_E     ;Enables LCD
                movlw   1               ;Wait 1ms
                call    LcdDelay
                bcf     LCD_E     ;Disabled LCD
                return
;========================================================================
;         CONVERTE PARA ASCII E ENVIA PARA SADA SERIAL
;========================================================================

B_ASC_ED  					  ;ROTINA DE BINARIO PARA HEX 0-F COM ENVIO PARA SERIAL
	   			 ANDLW 0X0F                ;LIMITA 0-F
	   			 ADDLW 0XF6				  ;SOMA 0XF6
	   			 BTFSC STATUS,C            ;TESTA CARRY
	   			 ADDLW 0X07                ;C=1 ,ENTO SOMA + 7
	   			 ADDLW 0X3A                ;SOMA 0X3A
           				  ;ENVIA PARA A SERIAL E RETORNA PARA O PONTO DE CHAMADA

;========================================================================
;ROTINA DE ENVIO DA SERIAL (9600 BAUDS)  'W' EST COM O BIT A TRANSMITIR
SEND
             MOVWF  BUFFER
             MOVLW  .8
             MOVWF  CNT
             BCF   T_232      ;ENVIA START BIT
             MOVLW  .29     
             CALL  T_BAUD
VTP1
             RRF   BUFFER,F
             BTFSS  STATUS,C
             BCF   T_232
             BTFSC  STATUS,C
             BSF   T_232
             NOP
			 MOVLW  .29
             CALL  T_BAUD
             DECFSZ  CNT,F
             GOTO   VTP1
             BSF    T_232    ;STOP BIT
             MOVLW  .29
             GOTO  T_BAUD    ;RETURN NA ROTINA (ECONOMIA)
             

;TEMPO DE 26 uSEG (INCLUINDO RETORNO)
T_BAUD
			
            MOVWF  CNT1
            DECFSZ CNT1,F
            GOTO   $-1
   			RETURN
;====================================================================================
;       ROTINA DE ENVIO DO NMERO SERIAL DO TX RECEBIDO PELO PINO 1 (9600 BAUDS)
;====================================================================================

ENVIA_NSERIAL
    
	SWAPF RES3,W
    CALL B_ASC_ED
    MOVFW RES3
    CALL B_ASC_ED

	SWAPF RES2,W
    CALL B_ASC_ED
    MOVFW RES2
    CALL B_ASC_ED

	SWAPF RES1,W
    CALL B_ASC_ED
    MOVFW RES1
    CALL B_ASC_ED

	SWAPF RES0,W
    CALL B_ASC_ED
    MOVFW RES0
    CALL B_ASC_ED
    CALL  V_BOT         ;ENVIA QUAIS SAIDAS FORAM ACIONADAS
    CALL B_ASC_ED
	RETURN
;====================================================================================
;       ROTINA DE VERIFICAO DE QUAL SAIDA FOI ACIONADA
;====================================================================================

V_BOT
    BTFSS BOT,6  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO 
    GOTO  SFI
    BTFSS BOT,5  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO 
    GOTO  SFI
    RETLW  0X33    ;AS DUAS SADAS FORAM ACIONADAS
SFI
    BTFSS BOT,5  ;TESTA QUAIS BOTES FORAM ACIONADOS NA TRANSMISSO 
    RETLW  0X32    ;SADA 2 APENAS
    RETLW  0X31    ;SADA 1 APENAS


 
			END














